%To calculate cut fill volume between a surface and a plane with constant
%elevation
%Can be modified to calculate volume between two surfaces
disp('*****START OF CODE*****')
clear all
%%
%inputs
zp=140; %level of intersecting plane from flume bed (in mm)
       %in this case, it is equal to thickness of sediment layer

%%
%First surface
% data import
xyzdata = xlsread('HL 03_01_01.xlsx'); %change file name as per requirement
x=xyzdata(:,1);
y=xyzdata(:,2);
z=xyzdata(:,3);
%interpolation
xlin = linspace(min(x),max(x),601); %change no. of grid points in x dir
ylin = linspace(min(y),max(y),301); %change no. of grid points in y dir
[X,Y] = meshgrid(xlin,ylin);
Z = griddata(x,y,z,X,Y,'natural');

%%
%Reference Plane
Zfill=Z;
Zcut=Z;
Zp=zp+(Z-Z); %to assign zp in all nodes to represent a plane
%interpolation> use this if second surface is needed
% Zp = griddata(x,y,zp,X,Y,'natural'); 

%%
%calculate fill volume
tempindex1=(Zfill>Zp);
Zfill(tempindex1)=Zp(tempindex1);
Znetf=(Zp-Zfill);
delx=abs(xlin(2)-xlin(1));
dely=abs(ylin(2)-ylin(1));
Volfill=sum(sum(Znetf))*delx*dely;
display('fill Volume= ')
disp(Volfill)
%%
%calculate cut volume
tempindex2=(Zcut<Zp);
Zcut(tempindex2)=Zp(tempindex2);
Znetc=(Zp-Zcut);
delx=abs(xlin(2)-xlin(1));
dely=abs(ylin(2)-ylin(1));
Volcut=sum(sum(Znetc))*delx*dely;
display('Cut Volume= ')
disp(Volcut)
disp('*****END OF CODE*****')
% figure
% h=surf(X,Y,Zp);
% hold on
% h=surf(X,Y,Z);
