%% data import
xyzdata = xlsread('HL 03_01_01.xlsx');
x=xyzdata(:,1);
y=xyzdata(:,2);
z=xyzdata(:,3);

% changing mm data into meters
x=x/1000;
y=y/1000;
z=z/1000;

%interpolation
xlin = linspace(min(x),max(x),600);
ylin = linspace(min(y),max(y),600);
[X,Y] = meshgrid(xlin,ylin);
%f = scatteredInterpolant(x,y,z);
%Z = f(X,Y);

Z = griddata(x,y,z,X,Y,'natural');


figure1=figure('units','normalized','outerposition',[0 0 1 1])
axes1 = axes('Parent',figure1);
hold(axes1,'on');
xlim(axes1,[0 0.6]);
% Uncomment the following line to preserve the Y-limits of the axes
ylim(axes1,[-0.3 0]);
% Uncomment the following line to preserve the Z-limits of the axes
zlim(axes1,[0 0.3]);
h=surf(X,Y,Z); %interpolated
hc=contour3(X,Y,Z,14,'-k'); %plots black contour lines with 20 contour levels
shading interp
axis manual
plot3(x,y,z,'.');
% view(axes1,[-152.7 48.4]);
view(axes1,[0 90]);
grid(axes1,'on');
hold off

%%to plot 2d profile at x=0.3m
% xi=[0:0.015:0.6];
% yi=[0:-0.00025:-0.25];
% 
% [X,Y] = meshgrid(xi,yi);
% Z = griddata(x,y,z,X,Y,'natural');
% 
% iy = Y(X == 0.3);
% iz = Z(X ==0.3);
% figure(2);
% plot(abs(iy), iz)
% grid on
% set(gca,'XTick',0:0.01:0.6)
% set(gca,'YTick',0:0.005:0.2)
% title('Plot Z(Y,X=0.3)')

%%to plot 2d cross section at y=0.3m
% ix = X(Y == 0.3);
% iz = Z(Y == -0.3);
% figure(3);
% plot(ix, iz,'*-')
% grid on
% set(gca,'XTick',0:0.02:0.2)
% set(gca,'YTick',0:0.005:0.6)
% title('Plot Z(X,Y=0.3)')

