 %plots 3d surface and plots 2d cross section at y=-0.02m

height=17; % height of sensors in cm
Hs=14; %initial sediment height in cm
%% data import
xyzdata = xlsread('test 07_01_01.xlsx');
x=xyzdata(:,1);
y=xyzdata(:,2);
z=xyzdata(:,3);
z=(height-z)./100;

%% to assign new xy values as measured in the flume
%<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
new_xy=xlsread('new_xy.xlsx');
x=new_xy(:,1);
y=new_xy(:,2);
%>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

%% assigning zero to negative z values
tempindex=z<0;
z(tempindex)=0;

tempindex1=z>Hs/100;
z(tempindex1)=Hs/100;

csvwrite('xyzdata.csv',[x y z])

xlin = linspace(min(x),max(x),120);
ylin = linspace(min(y),max(y),360);
[X,Y] = meshgrid(xlin,ylin);
%f = scatteredInterpolant(x,y,z);
%Z = f(X,Y);

Z = griddata(x,y,z,X,Y,'natural');


figure1=figure('units','normalized','outerposition',[0 0 1 1])
axes1 = axes('Parent',figure1);
hold(axes1,'on');
xlim(axes1,[0 0.6]);
% Uncomment the following line to preserve the Y-limits of the axes
ylim(axes1,[-0.6 0]);
% Uncomment the following line to preserve the Z-limits of the axes
zlim(axes1,[0 0.3]);
h=surf(X,Y,Z); %interpolated
hc=contour3(X,Y,Z,14,'-k'); %plots black contour lines with 20 contour levels
shading interp
axis manual
% plot3(x,y,z,'.');
% view(axes1,[-152.7 48.4]);
view(axes1,[0 90]);
grid(axes1,'on');
hold off

%%to plot 2d profile at x=0.3m
xi=[0:0.015:0.6];
yi=[0:-0.00025:-0.25];

[X,Y] = meshgrid(xi,yi);
Z = griddata(x,y,z,X,Y,'natural');

iy = Y(X == 0.3);
iz = Z(X ==0.3);
figure(2);
plot(abs(iy), iz)
grid on
set(gca,'XTick',0:0.01:0.6)
set(gca,'YTick',0:0.005:0.2)
title('Plot Z(Y,X=0.3)')

%%to plot 2d cross section at y=-0.02m
ix = X(Y == -0.02);
iz = Z(Y == -0.02);
figure(3);
plot(ix, iz,'*-')
grid on
set(gca,'XTick',0:0.02:0.6)
set(gca,'YTick',0:0.005:0.2)
title('Plot Z(X,Y=-0.02)')

%%to plot 2d cross section at y=-0.07m
ix = X(Y == -0.07);
iz = Z(Y == -0.07);
figure(4);
plot(ix, iz,'*-')
grid on
title('Plot Z(X,Y=-0.07)')

%%to plot 2d cross section at y=-0.12m
ix = X(Y == -0.12);
iz = Z(Y == -0.12);
figure(5);
plot(ix, iz,'*-')
grid on
title('Plot Z(X,Y=-0.12)')
